Index: /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 766)
@@ -2,4 +2,5 @@
      $           dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $           tnondef,tsumSTD)
+      USE dimphy
       IMPLICIT none
 c
@@ -20,8 +21,8 @@
 c NB: mettre "inst(X)" dans le write_histXXX.h !
 c====================================================================
-#include "dimensions.h"
-      integer jjmp1
-      parameter (jjmp1=jjm+1-1/jjm)
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym      integer jjmp1
+cym      parameter (jjmp1=jjm+1-1/jjm)
+cym#include "dimphy.h"
 c
 c variables Input
Index: /LMDZ4/trunk/libf/phylmd/moyglo_aire.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/moyglo_aire.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/moyglo_aire.F	(revision 766)
@@ -2,4 +2,5 @@
      .            ok_msk, msk, moyglo)
 c
+       USE dimphy
        IMPLICIT none
 c
@@ -14,5 +15,5 @@
 c
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
        INTEGER i, nhori
        REAL champ(klon), aire(klon), msk(klon)
@@ -61,4 +62,5 @@
        SUBROUTINE moyglo_pondaima(nhori, nvert, champ,
      . aire, pbord, moyglo)
+       USE dimphy
        IMPLICIT none
 c ==================================================================
@@ -72,5 +74,5 @@
 c ==================================================================
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
        INTEGER i, k, nhori, nvert
@@ -107,4 +109,5 @@
        SUBROUTINE moyglo_pondmass(nhori, nvert, champ,
      . aire, pbord, moyglo)
+       USE dimphy
        IMPLICIT none
 c ==================================================================
@@ -118,5 +121,5 @@
 c ==================================================================
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
        INTEGER i, k, nhori, nvert
Index: /LMDZ4/trunk/libf/phylmd/mpiclim.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/mpiclim.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/mpiclim.h	(revision 766)
@@ -21,4 +21,5 @@
 C
       common/CLIM_mpiclim/mpi_totproc, mpi_nproc, cmpi_modnam 
+c$OMP THREADPRIVATE(/CLIM_mpiclim/)
 C
 C     -----------------------------------------------------------------
Index: /LMDZ4/trunk/libf/phylmd/newmicro.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/newmicro.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/newmicro.F	(revision 766)
@@ -10,4 +10,5 @@
      e                  bl95_b0, bl95_b1,
      s                  cldtaupi, re, fl)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -39,6 +40,6 @@
 #include "YOMCST.h"
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "nuage.h"
 cIM cf. CR: include pour NOVLP et ZEPSEC
@@ -116,4 +117,5 @@
        xflwp(i)=0.
        xfiwp(i)=0.
+cccccccccccc!CDIR NOVECTOR
       DO k = 1, klev
 c
Index: /LMDZ4/trunk/libf/phylmd/nflxtr.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/nflxtr.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/nflxtr.F	(revision 766)
@@ -4,4 +4,5 @@
       SUBROUTINE nflxtr(pdtime,pmfu,pmfd,pen_u,pde_u,pen_d,pde_d,
      .                 pplay,paprs,x,dx) 
+      USE dimphy
       IMPLICIT NONE 
 c=====================================================================
@@ -21,6 +22,6 @@
 c=====================================================================
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOECUMF.h" 
Index: /LMDZ4/trunk/libf/phylmd/nuage.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/nuage.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/nuage.F	(revision 766)
@@ -9,4 +9,5 @@
      e                  bl95_b0, bl95_b1,
      s                  cldtaupi, re, fl)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -38,6 +39,6 @@
 #include "YOMCST.h"
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
       REAL paprs(klon,klev+1), pplay(klon,klev)
       REAL t(klon,klev)
@@ -229,4 +230,5 @@
       SUBROUTINE diagcld1(paprs,pplay,rain,snow,kbot,ktop,
      .                   diafra,dialiq)
+      use dimphy
       IMPLICIT none
 c
@@ -238,6 +240,6 @@
 c ces nuages. Je dois avouer que c'est une frustration.
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -313,8 +315,9 @@
       END
       SUBROUTINE diagcld2(paprs,pplay,t,q, diafra,dialiq)
+      use dimphy
       IMPLICIT none
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
Index: /LMDZ4/trunk/libf/phylmd/nuage.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/nuage.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/nuage.h	(revision 766)
@@ -5,2 +5,3 @@
 
       common /nuagecom/ rad_froid,rad_chau1, rad_chau2
+!$OMP THREADPRIVATE(/nuagecom/)
Index: /LMDZ4/trunk/libf/phylmd/oasis.dummy
===================================================================
--- /LMDZ4/trunk/libf/phylmd/oasis.dummy	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/oasis.dummy	(revision 766)
@@ -95,8 +95,8 @@
       cl_writ(18)='CORIVFLU'
       cl_writ(19)='COCALVIN'
-c$$$      cl_writ(13)='COZOTAUX'
-c$$$      cl_writ(14)='COZOTAUV'
-c$$$      cl_writ(15)='COMETAUY'
-c$$$      cl_writ(16)='COMETAUU'
+cxxx      cl_writ(13)='COZOTAUX'
+cxxx      cl_writ(14)='COZOTAUV'
+cxxx      cl_writ(15)='COMETAUY'
+cxxx      cl_writ(16)='COMETAUU'
       cl_writ(1)='COTAUXXU'
       cl_writ(2)='COTAUYYU'
@@ -365,8 +365,8 @@
       REAL rivrunoff(imjm)
       REAL calving(imjm)
-c$$$      REAL tauxu(imjm)
-c$$$      REAL tauxv(imjm)
-c$$$      REAL tauyu(imjm)
-c$$$      REAL tauyv(imjm)
+cxxx      REAL tauxu(imjm)
+cxxx      REAL tauxv(imjm)
+cxxx      REAL tauyu(imjm)
+cxxx      REAL tauyv(imjm)
       REAL tauxx_u(imjm)
       REAL tauxx_v(imjm)
@@ -496,16 +496,16 @@
      $          CALL locwrite(cl_writ(jf),calving, imjm,
      $          file_unit_field(jf), ierror) 
-c$$$            IF (jf.eq.13)
-c$$$     $          CALL locwrite(cl_writ(jf),tauxu, imjm,
-c$$$     $          file_unit_field(jf),ierror) 
-c$$$            IF (jf.eq.1')
-c$$$     $          CALL locwrite(cl_writ(jf),tauxv, imjm,
-c$$$     $          file_unit_field(jf),ierror) 
-c$$$            IF (jf.eq.15)
-c$$$     $          CALL locwrite(cl_writ(jf),tauyv, imjm,
-c$$$     $          file_unit_field(jf),ierror) 
-c$$$            IF (jf.eq.16)
-c$$$     $          CALL locwrite(cl_writ(jf),tauyu, imjm,
-c$$$     $          file_unit_field(jf), ierror) 
+cxxx            IF (jf.eq.13)
+cxxx     $          CALL locwrite(cl_writ(jf),tauxu, imjm,
+cxxx     $          file_unit_field(jf),ierror) 
+cxxx            IF (jf.eq.1')
+cxxx     $          CALL locwrite(cl_writ(jf),tauxv, imjm,
+cxxx     $          file_unit_field(jf),ierror) 
+cxxx            IF (jf.eq.15)
+cxxx     $          CALL locwrite(cl_writ(jf),tauyv, imjm,
+cxxx     $          file_unit_field(jf),ierror) 
+cxxx            IF (jf.eq.16)
+cxxx     $          CALL locwrite(cl_writ(jf),tauyu, imjm,
+cxxx     $          file_unit_field(jf), ierror) 
             IF (jf.eq.1)
      $          CALL locwrite(cl_writ(jf),tauxx_u, imjm,
@@ -574,8 +574,8 @@
           IF (jn.eq.18) CALL CLIM_Export(cl_writ(jn),kt,rivrunoff,info)
           IF (jn.eq.19) CALL CLIM_Export(cl_writ(jn),kt,calving,info)
-c$$$          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxu, info)
-c$$$          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauxv, info)
-c$$$          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauyv, info)
-c$$$          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauyu, info)
+cxxx          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxu, info)
+cxxx          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauxv, info)
+cxxx          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauyv, info)
+cxxx          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauyu, info)
           IF (jn.eq.1) CALL CLIM_Export(cl_writ(jn), kt, tauxx_u, info)
           IF (jn.eq.2) CALL CLIM_Export(cl_writ(jn), kt, tauyy_u, info)
Index: /LMDZ4/trunk/libf/phylmd/oasis.psmile
===================================================================
--- /LMDZ4/trunk/libf/phylmd/oasis.psmile	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/oasis.psmile	(revision 766)
@@ -45,5 +45,5 @@
    use mod_prism_proto
    use mod_prism_def_partition_proto
-
+   use dimphy
    implicit none
 
@@ -94,16 +94,16 @@
 ! Here we go: psmile initialisation
 !
-   call prism_init_comp_proto (comp_id, clmodnam, ierror)
-
-   IF (ierror .ne. PRISM_Ok) THEN
-      abort_message=' Probleme init dans prism_init_comp '
-      call abort_gcm(modname,abort_message,1)
-   ELSE
-      WRITE(nuout,*) 'inicma : init psmile ok '
-   ENDIF
-
-! PSMILe attribution of local communicator
-!
-   call prism_get_localcomm_proto (il_commlocal, ierror)
+    IF (monocpu) THEN
+      call prism_init_comp_proto (comp_id, clmodnam, ierror)
+
+      IF (ierror .ne. PRISM_Ok) THEN
+         abort_message=' Probleme init dans prism_init_comp '
+         call abort_gcm(modname,abort_message,1)
+      ELSE
+         WRITE(nuout,*) 'inicma : init psmile ok '
+      ENDIF
+    ENDIF
+
+      call prism_get_localcomm_proto (il_commlocal, ierror)
 !
 ! and domain decomposition
@@ -111,11 +111,15 @@
 ! monoproc case
 !
-   allocate(ig_paral(5))
-   ig_paral (1) = 2
-   ig_paral (2) = 0
-   ig_paral (3) = im
-   ig_paral (4) = jm
-   ig_paral (5) = im
-
+   allocate(ig_paral(3))
+!ym   ig_paral(1) = 0
+!ym   ig_paral(2) = 0
+!ym   ig_paral(3) = im * jm
+   ig_paral(1) = 1    ! apple partition for //
+   ig_paral(2) = (jjphy_begin-1)*im+iiphy_begin-1
+   ig_paral(3) = (jjphy_end*im+iiphy_end)-(jjphy_begin*im+iiphy_begin)+1
+   if (phy_rank==phy_size-1) ig_paral(3)=ig_paral(3)+im-1
+   print *,phy_rank,'ig_paral--->',ig_paral(2),ig_paral(3)
+   
+   ierror=PRISM_Ok
    call prism_def_partition_proto (il_part_id, ig_paral, ierror)
    deallocate(ig_paral)
@@ -140,7 +144,7 @@
       cl_writ(5)='COTAUYYV'
       cl_writ(6)='COTAUZZV'
-c -- LOOP
+! -- LOOP
       cl_writ(7)='COWINDSP'
-c -- LOOP
+! -- LOOP
       cl_writ(8)='COSHFICE'
       cl_writ(9)='COSHFOCE'
@@ -218,5 +222,5 @@
    use mod_prism_proto
    use mod_prism_get_proto
-
+   use dimphy
    IMPLICIT none
 
@@ -225,8 +229,8 @@
 !
    integer                 :: im, jm, kt
-   real, dimension(im, jm)   :: sst            ! sea-surface-temperature
-   real, dimension(im, jm)   :: gla     ! sea-ice
-   real, dimension(im, jm)   :: tice    ! temp glace
-   real, dimension(im, jm)   :: albedo  ! albedo glace
+   real, dimension(im*jm)   :: sst            ! sea-surface-temperature
+   real, dimension(im*jm)   :: gla     ! sea-ice
+   real, dimension(im*jm)   :: tice    ! temp glace
+   real, dimension(im*jm)   :: albedo  ! albedo glace
 !
 ! local variables
@@ -236,4 +240,5 @@
    character (len = 20),save  :: modname = 'fromcpl'
    character (len = 80)       :: abort_message 
+   integer :: istart,iend
 !
 #include "param_cou.h"
@@ -245,5 +250,12 @@
    CALL flush (nuout)
 
-   call prism_get_proto(in_var_id(1), kt, sst, ierror)
+   istart=iiphy_begin
+   if (phy_rank==phy_size-1) then
+    iend=(jjphy_end-jjphy_begin)*im+im
+   else
+    iend=(jjphy_end-jjphy_begin)*im+iiphy_end
+   endif
+   
+   call prism_get_proto(in_var_id(1), kt, sst(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Recvd .and. &
  &     ierror.ne.PRISM_FromRest &
@@ -254,5 +266,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_get_proto(in_var_id(2), kt, gla, ierror)
+   call prism_get_proto(in_var_id(2), kt, gla(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Recvd .and. &
  &     ierror.ne.PRISM_FromRest &
@@ -263,5 +275,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_get_proto(in_var_id(3), kt, albedo, ierror)
+   call prism_get_proto(in_var_id(3), kt, albedo(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Recvd .and. &
  &     ierror.ne.PRISM_FromRest &
@@ -272,5 +284,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_get_proto(in_var_id(4), kt, tice, ierror)
+   call prism_get_proto(in_var_id(4), kt, tice(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Recvd .and. &
  &     ierror.ne.PRISM_FromRest &
@@ -288,9 +300,9 @@
    SUBROUTINE intocpl(kt, im, jm, fsolice, fsolwat, fnsolice, fnsolwat, &
  &    fnsicedt, evice, evwat, lpre, spre, dirunoff, rivrunoff, & 
- &    calving, tauxx_u, tauyy_u, tauzz_u, tauxx_v, tauyy_v, tauzz_v &
-c -- LOOP
-     $    windsp,
-c -- LOOP
- &    , last) 
+ &    calving, tauxx_u, tauyy_u, tauzz_u, tauxx_v, tauyy_v, tauzz_v, &
+! -- LOOP
+ &    windsp,                                                       &
+! -- LOOP
+ &    last) 
 ! ======================================================================
 ! L. Fairhead (09/2003) adapted From L.Z.X Li: this subroutine provides the 
@@ -301,5 +313,6 @@
    use mod_prism_proto
    use mod_prism_put_proto
-
+   use dimphy
+   use write_field_phy
    IMPLICIT NONE
 
@@ -308,11 +321,14 @@
 !
    integer               :: kt, im, jm
-   real, dimension(im, jm) :: fsolice, fsolwat, fnsolwat, fnsolice
-   real, dimension(im, jm) :: fnsicedt, evice, evwat, lpre, spre
-   real, dimension(im, jm) :: dirunoff, rivrunoff, calving
-   real, dimension(im, jm) :: tauxx_u, tauxx_v, tauyy_u
-   real, dimension(im, jm) :: tauyy_v, tauzz_u, tauzz_v
-   real, dimension(im, jm) :: windsp
+   real, dimension(im* jm) :: fsolice, fsolwat, fnsolwat, fnsolice
+   real, dimension(im* jm) :: fnsicedt, evice, evwat, lpre, spre
+   real, dimension(im* jm) :: dirunoff, rivrunoff, calving
+   real, dimension(im* jm) :: tauxx_u, tauxx_v, tauyy_u
+   real, dimension(im* jm) :: tauyy_v, tauzz_u, tauzz_v
+   real, dimension(im*jm) :: windsp
    logical               :: last
+   logical :: checkout=.FALSE.
+   integer :: istart,iend
+   integer :: wstart,wend
 !
 ! local
@@ -329,5 +345,39 @@
       WRITE(nuout,*)
 
-   call prism_put_proto(il_out_var_id(8), kt, fsolice, ierror)
+   istart=iiphy_begin
+   if (phy_rank==phy_size-1) then
+    iend=(jjphy_end-jjphy_begin)*im+im
+   else
+    iend=(jjphy_end-jjphy_begin)*im+iiphy_end
+   endif
+
+   IF (checkout) THEN   
+     wstart=istart
+     wend=iend
+     IF (phy_rank==0) wstart=istart+im-1
+     IF (phy_rank==phy_size-1) wend=iend-im+1
+   
+     CALL writeField_phy("fsolice",fsolice(wstart:wend),1)
+     CALL writeField_phy("fsolwat",fsolwat(wstart:wend),1)
+     CALL writeField_phy("fnsolice",fnsolice(wstart:wend),1)
+     CALL writeField_phy("fnsolwat",fnsolwat(wstart:wend),1)
+     CALL writeField_phy("fnsicedt",fnsicedt(wstart:wend),1)
+     CALL writeField_phy("evice",evice(wstart:wend),1)
+     CALL writeField_phy("evwat",evwat(wstart:wend),1)
+     CALL writeField_phy("lpre",lpre(wstart:wend),1)
+     CALL writeField_phy("spre",spre(wstart:wend),1)
+     CALL writeField_phy("dirunoff",dirunoff(wstart:wend),1)
+     CALL writeField_phy("rivrunoff",rivrunoff(wstart:wend),1)
+     CALL writeField_phy("calving",calving(wstart:wend),1)
+     CALL writeField_phy("tauxx_u",tauxx_u(wstart:wend),1)
+     CALL writeField_phy("tauyy_u",tauyy_u(wstart:wend),1)
+     CALL writeField_phy("tauzz_u",tauzz_u(wstart:wend),1)
+     CALL writeField_phy("tauxx_v",tauxx_v(wstart:wend),1)
+     CALL writeField_phy("tauyy_v",tauyy_v(wstart:wend),1)
+     CALL writeField_phy("tauzz_v",tauzz_v(wstart:wend),1)
+     CALL writeField_phy("windsp",windsp(wstart:wend),1)
+   ENDIF
+   
+   call prism_put_proto(il_out_var_id(8), kt, fsolice(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -337,5 +387,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(9), kt, fsolwat, ierror)
+   call prism_put_proto(il_out_var_id(9), kt, fsolwat(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -345,5 +395,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(10), kt, fnsolice, ierror)
+   call prism_put_proto(il_out_var_id(10), kt, fnsolice(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -353,5 +403,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(11), kt, fnsolwat, ierror)
+   call prism_put_proto(il_out_var_id(11), kt, fnsolwat(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -361,5 +411,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(12), kt, fnsicedt, ierror)
+   call prism_put_proto(il_out_var_id(12), kt, fnsicedt(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -369,5 +419,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(13), kt, evice, ierror)
+   call prism_put_proto(il_out_var_id(13), kt, evice(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -377,5 +427,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(14), kt, evwat, ierror)
+   call prism_put_proto(il_out_var_id(14), kt, evwat(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -385,5 +435,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(15), kt, lpre, ierror)
+   call prism_put_proto(il_out_var_id(15), kt, lpre(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -393,5 +443,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(16), kt, spre, ierror)
+   call prism_put_proto(il_out_var_id(16), kt, spre(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -401,5 +451,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(17), kt, dirunoff, ierror)
+   call prism_put_proto(il_out_var_id(17), kt, dirunoff(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -409,5 +459,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(18), kt, rivrunoff, ierror)
+   call prism_put_proto(il_out_var_id(18), kt, rivrunoff(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -417,5 +467,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(19), kt, calving, ierror)
+   call prism_put_proto(il_out_var_id(19), kt, calving(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -425,5 +475,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(1), kt, tauxx_u, ierror)
+   call prism_put_proto(il_out_var_id(1), kt, tauxx_u(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -433,5 +483,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(2), kt, tauyy_u, ierror)
+   call prism_put_proto(il_out_var_id(2), kt, tauyy_u(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -441,5 +491,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(3), kt, tauzz_u, ierror)
+   call prism_put_proto(il_out_var_id(3), kt, tauzz_u(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -449,5 +499,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(4), kt, tauxx_v, ierror)
+   call prism_put_proto(il_out_var_id(4), kt, tauxx_v(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -457,5 +507,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(5), kt, tauyy_v, ierror)
+   call prism_put_proto(il_out_var_id(5), kt, tauyy_v(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -465,5 +515,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(6), kt, tauzz_v, ierror)
+   call prism_put_proto(il_out_var_id(6), kt, tauzz_v(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -473,5 +523,5 @@
      call abort_gcm(modname,abort_message,1)
    endif
-   call prism_put_proto(il_out_var_id(7), kt, windsp, ierror)
+   call prism_put_proto(il_out_var_id(7), kt, windsp(istart:iend), ierror)
    IF (ierror .ne. PRISM_Ok .and. ierror.ne.PRISM_Sent .and. ierror.ne.PRISM_ToRest &
  &     .and. ierror.ne.PRISM_LocTrans .and. ierror.ne.PRISM_Output .and. &
@@ -483,9 +533,11 @@
 
    if (last) then
-     call prism_terminate_proto(ierror)
-     IF (ierror .ne. PRISM_Ok) THEN
-       abort_message=' Probleme dans prism_terminate_proto '
-       call abort_gcm(modname,abort_message,1)
-     endif
+     IF (monocpu) THEN 
+       call prism_terminate_proto(ierror)
+         IF (ierror .ne. PRISM_Ok) THEN
+         abort_message=' Probleme dans prism_terminate_proto '
+         call abort_gcm(modname,abort_message,1)
+       endif
+     ENDIF
    endif
 
Index: /LMDZ4/trunk/libf/phylmd/orbite.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/orbite.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/orbite.F	(revision 766)
@@ -49,4 +49,5 @@
 c======================================================================
       SUBROUTINE angle(longi, lati, frac, muzero)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -64,6 +65,6 @@
 c                   la journee (0 a 1)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
       REAL longi
       REAL lati(klon), frac(klon), muzero(klon)
@@ -108,4 +109,5 @@
       SUBROUTINE zenang(longi,gmtime,pdtrad,lat,long,
      s                  pmu0,frac)
+      USE dimphy
       IMPLICIT none
 c=============================================================
@@ -131,6 +133,6 @@
 c frac-----OUTPUT: ensoleillement moyen entre gmtime et gmtime+pdtrad
 c================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c================================================================
@@ -261,4 +263,5 @@
       SUBROUTINE zenith (longi, gmtime, lat, long,
      s                   pmu0, fract)
+      USE dimphy
       IMPLICIT none
 c
@@ -278,6 +281,6 @@
 c
 c====================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c====================================================================
Index: /LMDZ4/trunk/libf/phylmd/orografi.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/orografi.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/orografi.F	(revision 766)
@@ -9,4 +9,5 @@
      s                   d_t, d_u, d_v)
 c
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -26,6 +27,6 @@
 c d_v-----output-R-increment de la vitesse v
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -132,4 +133,5 @@
      r                 , pvom,pvol,pte )
 
+      USE dimphy
       implicit none
 
@@ -181,6 +183,6 @@
 c
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOEGWD.h"
@@ -191,5 +193,6 @@
 c
 c
-      integer nlon, nlev, klevm1
+cym      integer nlon, nlev, klevm1
+      integer nlon, nlev
       integer kgwd, jl, ilevp1, jk, ji
       real zdelp, ztemp, zforc, ztend
@@ -259,5 +262,5 @@
 c     ztmst=twodt
 c     if(nstep.eq.nstart) ztmst=0.5*twodt
-      klevm1=klev-1
+cym      klevm1=klev-1
       ztmst=ptsphy
       zrtmst=1./ztmst
@@ -466,9 +469,10 @@
 c
 c-----------------------------------------------------------------------
+      USE dimphy
       implicit none
 c
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOEGWD.h"
@@ -934,7 +938,8 @@
 c
 c-----------------------------------------------------------------------
+      USE dimphy
       implicit none
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOEGWD.h"
@@ -1068,4 +1073,5 @@
 C     PASSAGE OF THE NEW GWDRAG TO I.F.S. (F. LOTT, 22/11/93)
 C-----------------------------------------------------------------------
+      USE dimphy
       implicit none
 C
@@ -1073,6 +1079,6 @@
 C
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOEGWD.h"
@@ -1299,4 +1305,5 @@
      s                   d_t, d_u, d_v)
 c
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1316,6 +1323,6 @@
 c d_v-----output-R-increment de la vitesse v
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -1439,9 +1446,10 @@
 C     F.LOTT  LMD 22/11/95
 C
+      USE dimphy
       implicit none
 C
 C
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOEGWD.h"
@@ -1473,6 +1481,7 @@
 C*       0.2   LOCAL ARRAYS
 C              ------------
-      logical lifthigh
-      integer klevm1, jl, ilevh, jk
+      logical lifthigh, ll1
+cym      integer klevm1, jl, ilevh, jk
+      integer  jl, ilevh, jk
       real zcons1, ztmst, zrtmst,zpi, zhgeo
       real zdelp, zslow, zsqua, zscav, zbet
@@ -1497,5 +1506,5 @@
       IF(NLON.NE.KLON.OR.NLEV.NE.KLEV)STOP
       ZCONS1=1./RD
-      KLEVM1=KLEV-1
+cym      KLEVM1=KLEV-1
       ZTMST=PTSPHY
       ZRTMST=1./ZTMST
@@ -1698,5 +1707,9 @@
       RETURN
       END
+
+
       SUBROUTINE SUGWD(NLON,NLEV,paprs,pplay)
+      USE dimphy
+c      USE parallel
 C
 C**** *SUGWD* INITIALIZE COMMON YOEGWD CONTROLLING GRAVITY WAVE DRAG
@@ -1751,4 +1764,9 @@
       REAL pplay(nlon,nlev)
       real zpr,zstra,zsigt,zpm1r
+      REAL,SAVE,ALLOCATABLE :: pplay_mpi(:,:)
+      REAL,SAVE,ALLOCATABLE :: paprs_mpi(:,:)
+      REAL,SAVE,ALLOCATABLE :: pplay_glo(:,:)
+      REAL,SAVE,ALLOCATABLE :: paprs_glo(:,:)
+
 C
 C*       1.    SET THE VALUES OF THE PARAMETERS
@@ -1766,14 +1784,41 @@
 cold  ZSIGT=0.85
 C
+c$OMP MASTER
+      ALLOCATE(pplay_mpi(klon_mpi,nlev))
+      ALLOCATE(paprs_mpi(klon_mpi,nlev+1))
+      ALLOCATE(pplay_glo(klon2,nlev))
+      ALLOCATE(paprs_glo(klon2,nlev+1))
+c$OMP END MASTER
+c$OMP BARRIER
+
+      CALL GatherField_omp(pplay,pplay_mpi,nlev)      
+      CALL GatherField_omp(paprs,paprs_mpi,nlev+1)
+
+c$OMP MASTER      
+      CALL  AllGatherField(pplay_mpi,pplay_glo,nlev)
+      CALL  AllGatherField(paprs_mpi,paprs_glo,nlev+1)
+c$OMP END MASTER
+c$OMP BARRIER
+      
       DO 110 JK=1,NLEV
-      ZPM1R=pplay(nlon/2,jk)/paprs(nlon/2,1) 
+      ZPM1R=pplay_glo(klon2/2,jk)/paprs_glo(klon2/2,1) 
       IF(ZPM1R.GE.ZSIGT)THEN
          nktopg=JK
       ENDIF
-      ZPM1R=pplay(nlon/2,jk)/paprs(nlon/2,1) 
+      ZPM1R=pplay_glo(klon2/2,jk)/paprs_glo(klon2/2,1) 
       IF(ZPM1R.GE.ZSTRA)THEN
          NSTRA=JK
       ENDIF
   110 CONTINUE
+
+c$OMP BARRIER
+c$OMP MASTER
+      DEALLOCATE(pplay_mpi)
+      DEALLOCATE(paprs_mpi)
+      DEALLOCATE(pplay_glo)
+      DEALLOCATE(paprs_glo)
+c$OMP END MASTER
+c$OMP BARRIER
+
 c
 c  inversion car dans orodrag on compte les niveaux a l'envers
Index: /LMDZ4/trunk/libf/phylmd/ozonecm.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ozonecm.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/ozonecm.F	(revision 766)
@@ -3,4 +3,5 @@
 !
       SUBROUTINE ozonecm(rjour, rlat, paprs, o3)
+      USE dimphy
       IMPLICIT none
 C
@@ -19,6 +20,6 @@
 C
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "clesphys.h"
 #include "YOMCST.h"
@@ -33,4 +34,5 @@
       REAL an, unit, zo3q3
       SAVE an, unit, zo3q3
+c$OMP THREADPRIVATE(an, unit, zo3q3)
       REAL mu,gms, zslat, zsint, zcost, z, ppm, qpm, a
       REAL asec, bsec, aprim, zo3a3
